local E, L, V, P, G = unpack(ElvUI)
local Tuk = E:GetModule("Tuk_Style")
local UF = E:GetModule('UnitFrames');

function Tuk:Options()
	E.Options.args.general.args.general.args.pixelPerfect.disabled = true
	E.Options.args.general.args.general.args.bottomPanel.disabled = true
	if E.private.tukui.chat then
		E.Options.args.datatexts.args.leftChatPanel.disabled = true
		E.Options.args.datatexts.args.rightChatPanel.disabled = true
		E.Options.args.datatexts.args.panelTransparency.disabled = true
	end
	
	E.Options.args.TukUIStyle = {
		type = "group",
		name = "|cffff8000TukUI Style|r",
		order = 60,
		args = {
			installButton = {
				order = 1,
				type = 'execute',
				name = L['Install'],
				width = 'full',
				desc = L['Run the installation process.'],
				func = function() Tuk:Setup(); E:ToggleConfig(); end,
			},	
			actionbars = {
				order = 2,
				name = L["ActionBars"],
				type = 'toggle',
				disabled = function() return not E.private.tukui.chat end,
				get = function(info) return E.private.tukui.actionbars end,
				set = function(info, value) E.private.tukui.actionbars = value; E:StaticPopup_Show("PRIVATE_RL") end
			},
			chat = {
				order = 3,
				name = L["Chat"],
				type = 'toggle',
				get = function(info) return E.private.tukui.chat end,
				set = function(info, value) E.private.tukui.chat = value; E:StaticPopup_Show("PRIVATE_RL") end
			},
			forcebordercolor = {
				order = 4,
				name = L["Force Border Color"],
				desc = L["Will reset border color on grey on every reload."],
				type = 'toggle',
				get = function(info) return E.private.tukui.forcebordercolor end,
				set = function(info, value) E.private.tukui.forcebordercolor = value; end
			},
			units = {
				type = "group",
				order = 11,
				name = L["UnitFrames"],
				guiInline = true,
				get = function(info) return E.private.tukui.unitframes[ info[#info] ] end,
				set = function(info, value) E.private.tukui.unitframes[ info[#info] ] = value; E:StaticPopup_Show("PRIVATE_RL") end,
				args = {
					player = {
						type = "toggle",
						order = 1,
						name = L["Player Frame"],
					},
					pet = {
						type = "toggle",
						order = 2,
						name = L["Pet Frame"],
					},
					target = {
						type = "toggle",
						order = 3,
						name = L["Target Frame"],
					},
					targettarget = {
						type = "toggle",
						order = 4,
						name = L["TargetTarget Frame"],
					},
					party = {
						type = "toggle",
						order = 4,
						name = L["Party Frames"],
					},
					raid = {
						type = "toggle",
						order = 6,
						name = L["Raid Frames"],
					},
					raid40 = {
						type = "toggle",
						order = 7,
						name = L["Raid-40 Frames"],
					},
					singleHeight = {
						order = 8,
						name = L["Empty Bar Height (Single)"],
						type = 'range',
						min = 5, max = 100, step = 1,
						set = function(info, value) E.private.tukui.unitframes[ info[#info] ] = value; UF:CreateAndUpdateUF('player');UF:CreateAndUpdateUF('target');UF:CreateAndUpdateUF('targettarget');UF:CreateAndUpdateUF('pet'); end,
					},
					groupHeight = {
						order = 9,
						name = L["Empty Bar Height (Group)"],
						type = 'range',
						min = 5, max = 100, step = 1,
						set = function(info, value) E.private.tukui.unitframes[ info[#info] ] = value; UF:CreateAndUpdateHeaderGroup('party');UF:CreateAndUpdateHeaderGroup('raid');UF:CreateAndUpdateHeaderGroup('raid40'); end,
					},
					threat = {
						order = 10,
						name = L["Threat Glow on EmptyBar"],
						desc = L["If threat style for the frame is set to \"Glow\" then it will be shown around the empty bar for that frame and not around the whole frame."],
						type = 'toggle',
					},
				},
			},
		},
	}
end