local E, L, V, P, G, _ = unpack(ElvUI);
local UFT = E:GetModule('tUnits');
local UF = E:GetModule('UnitFrames');

-- ToDo:
--		Move the default position and size the default detached Player/Target power bars
-- 		Currenlty, when detached, they position is half over the PlayerBar/TargetBar

local BORDER = E.Border;

local CAN_HAVE_CLASSBAR = (E.myclass == "PALADIN" or E.myclass == "DRUID" or E.myclass == "DEATHKNIGHT" or E.myclass == "WARLOCK" or E.myclass == "PRIEST" or E.myclass == "MONK" or E.myclass == 'MAGE' or E.myclass == 'ROGUE')

function UFT:UpdatePlayerBarAnchors(frame, isShown)
	local db = E.db['unitframe']['units'].player
	local threat = frame.Threat
	local bar = frame.emptyBar

	local POWERBAR_HEIGHT = db.power.height
	local CLASSBAR_HEIGHT = db.classbar.height
	local USE_CLASSBAR = db.classbar.enable
	local USE_MINI_CLASSBAR = db.classbar.fill == "spaced" and USE_CLASSBAR
	local SPACING = E.Spacing;

	local mini_classbarY = 0
	if USE_MINI_CLASSBAR then
		mini_classbarY = -(SPACING+(CLASSBAR_HEIGHT))
	end

	if isShown then
		if db.threatStyle == "GLOW" then
			if E.private.tukui.unitframes.threat then
				threat.glow:Point("TOPLEFT", bar, "TOPLEFT", -4, 4+mini_classbarY)
				threat.glow:Point("TOPRIGHT", bar, "TOPRIGHT", 4, 4+mini_classbarY)
			else
				threat.glow:Point("TOPLEFT", -4, 4+mini_classbarY)
				threat.glow:Point("TOPRIGHT", 4, 4+mini_classbarY)
			end

			if USE_MINI_POWERBAR then
				threat.glow:Point("BOTTOMLEFT", -4, -4 + (POWERBAR_HEIGHT/2))
				threat.glow:Point("BOTTOMRIGHT", 4, -4 + (POWERBAR_HEIGHT/2))
			else
				threat.glow:Point("BOTTOMLEFT", bar, "BOTTOMLEFT", -4, -4)
				threat.glow:Point("BOTTOMRIGHT", bar, "BOTTOMRIGHT", 4, -4)
			end

			if USE_POWERBAR_OFFSET then
				threat.glow:Point("TOPRIGHT", 4-POWERBAR_OFFSET, 4+mini_classbarY)
				threat.glow:Point("BOTTOMRIGHT", 4-POWERBAR_OFFSET, -4)
			end
		end
	else
		if db.threatStyle == "GLOW" then
			if E.private.tukui.unitframes.threat then
				threat.glow:Point("TOPLEFT", bar, "TOPLEFT", -4, 4)
				threat.glow:Point("TOPRIGHT", bar, "TOPRIGHT", 4, 4)
			else
				threat.glow:Point("TOPLEFT", -4, 4)
				threat.glow:Point("TOPRIGHT", 4, 4)
			end

			if USE_MINI_POWERBAR then
				threat.glow:Point("BOTTOMLEFT", -4, -4 + (POWERBAR_HEIGHT/2))
				threat.glow:Point("BOTTOMRIGHT", 4, -4 + (POWERBAR_HEIGHT/2))
			else
				threat.glow:Point("BOTTOMLEFT", bar, "BOTTOMLEFT", -4, -4)
				threat.glow:Point("BOTTOMRIGHT", bar, "BOTTOMRIGHT", 4, -4)
			end

			if USE_POWERBAR_OFFSET then
				threat.glow:Point("TOPRIGHT", 4-POWERBAR_OFFSET, 4)
				threat.glow:Point("BOTTOMRIGHT", 4-POWERBAR_OFFSET, -4)
			end
		end
	end
end

function UFT:UpdatePlayerBar(frame, db)
	local bar = frame.emptyBar

	local EMPTY_BARS_HEIGHT = E.private.tukui.unitframes.singleHeight -- Wew could make an option for it
	local USE_POWERBAR = db.power.enable
	local POWERBAR_HEIGHT = db.power.height
	local POWERBAR_OFFSET = db.power.offset
	local USE_INSET_POWERBAR = db.power.width == 'inset' and USE_POWERBAR
	local USE_MINI_POWERBAR = db.power.width == 'spaced' and USE_POWERBAR
	local POWERBAR_DETACHED = db.power.detachFromFrame
	local USE_POWERBAR_OFFSET = db.power.offset ~= 0 and USE_POWERBAR and not POWERBAR_DETACHED
	local USE_PORTRAIT = db.portrait.enable
	local USE_PORTRAIT_OVERLAY = db.portrait.overlay and USE_PORTRAIT

	local USE_CLASSBAR = db.classbar.enable and CAN_HAVE_CLASSBAR
	local USE_MINI_CLASSBAR = db.classbar.fill == "spaced" and USE_CLASSBAR and db.classbar.detachFromFrame ~= true
	local mini_classbarY = 0
	if USE_MINI_CLASSBAR then
		mini_classbarY = -(SPACING+(CLASSBAR_HEIGHT/2))
	end

	-- Empty Bar
	do
		local health = frame.Health
		local power = frame.Power
		if USE_POWERBAR_OFFSET then
			bar:Point('TOPLEFT', power, 'BOTTOMLEFT', -BORDER, -3)
			bar:Point('BOTTOMRIGHT', power, 'BOTTOMRIGHT', BORDER, -EMPTY_BARS_HEIGHT)
		elseif USE_MINI_POWERBAR or USE_INSET_POWERBAR then
			bar:Point('TOPLEFT', health, 'BOTTOMLEFT', -BORDER, -3)
			bar:Point('BOTTOMRIGHT', health, 'BOTTOMRIGHT', BORDER, -EMPTY_BARS_HEIGHT)
		elseif POWERBAR_DETACHED or not USE_POWERBAR then
			bar:Point('TOPLEFT', health.backdrop, 'BOTTOMLEFT', 0, -1)
			bar:Point('BOTTOMRIGHT', health.backdrop, 'BOTTOMRIGHT', 0, -EMPTY_BARS_HEIGHT)
		else
			bar:Point('TOPLEFT', power, 'BOTTOMLEFT', -BORDER, -3)
			bar:Point('BOTTOMRIGHT', power, 'BOTTOMRIGHT', BORDER, -EMPTY_BARS_HEIGHT)
		end

		if USE_PORTRAIT and not USE_PORTRAIT_OVERLAY then
			bar:Point('TOPLEFT', frame.Portrait.backdrop, 'BOTTOMLEFT', 0, -1)
		end
	end

	--Threat
	do
		local threat = frame.Threat

		if db.threatStyle ~= 'NONE' and db.threatStyle ~= nil then
			if db.threatStyle == "GLOW" then
				threat:SetFrameStrata('BACKGROUND')
				threat.glow:ClearAllPoints()
				threat.glow:SetBackdropBorderColor(0, 0, 0, 0)
				if E.private.tukui.unitframes.threat then
					threat.glow:Point("TOPLEFT", bar, "TOPLEFT", -4, 4+mini_classbarY)
					threat.glow:Point("TOPRIGHT", bar, "TOPRIGHT", 4, 4+mini_classbarY)
				else
					threat.glow:Point("TOPLEFT", -4, 4+mini_classbarY)
					threat.glow:Point("TOPRIGHT", 4, 4+mini_classbarY)
				end

				if USE_MINI_POWERBAR then
					threat.glow:Point("BOTTOMLEFT", bar, "BOTTOMLEFT", -4, -4)
					threat.glow:Point("BOTTOMRIGHT", bar, "BOTTOMRIGHT", 4, -4)
				else
					threat.glow:Point("BOTTOMLEFT", bar, "BOTTOMLEFT", -4, -4)
					threat.glow:Point("BOTTOMRIGHT", bar, "BOTTOMRIGHT", 4, -4)
				end

				if USE_POWERBAR_OFFSET then
					threat.glow:Point("TOPRIGHT", 4-POWERBAR_OFFSET, 4+mini_classbarY)
					threat.glow:Point("BOTTOMRIGHT", 4-POWERBAR_OFFSET, -4)

					if USE_PORTRAIT == true and not USE_PORTRAIT_OVERLAY then
						threat.glow:Point("BOTTOMLEFT", frame.Portrait.backdrop, "BOTTOMLEFT", -4, -4)
					else
						threat.glow:Point("BOTTOMLEFT", frame.Health, "BOTTOMLEFT", -5, -5)
					end
					threat.glow:Point("BOTTOMRIGHT", frame.Health, "BOTTOMRIGHT", 5, -5)
				end
			elseif db.threatStyle == "ICONTOPLEFT" or db.threatStyle == "ICONTOPRIGHT" or db.threatStyle == "ICONBOTTOMLEFT" or db.threatStyle == "ICONBOTTOMRIGHT" or db.threatStyle == "ICONTOP" or db.threatStyle == "ICONBOTTOM" or db.threatStyle == "ICONLEFT" or db.threatStyle == "ICONRIGHT" then
				threat:SetFrameStrata('HIGH')
				local point = db.threatStyle
				point = point:gsub("ICON", "")

				threat.texIcon:ClearAllPoints()
				threat.texIcon:SetPoint(point, frame.Health, point)
			end
		end
	end
end