local E, L, V, P, G, _ = unpack(ElvUI);
local UFT = E:GetModule('tUnits');
local UF = E:GetModule('UnitFrames');

-- ToDo:
--		Move the default position and size the default detached Player/Target power bars
-- 		Currenlty, when detached, they position is half over the PlayerBar/TargetBar

local BORDER = E.Border;

function UFT:UpdateTargetBar(frame, db)
	local bar = frame.emptyBar

	local EMPTY_BARS_HEIGHT = E.private.tukui.unitframes.singleHeight
	local USE_POWERBAR = db.power.enable
	local USE_INSET_POWERBAR = db.power.width == 'inset' and USE_POWERBAR
	local USE_MINI_POWERBAR = db.power.width == 'spaced' and USE_POWERBAR
	local POWERBAR_DETACHED = db.power.detachFromFrame
	local USE_POWERBAR_OFFSET = db.power.offset ~= 0 and USE_POWERBAR and not POWERBAR_DETACHED

	local USE_PORTRAIT = db.portrait and db.portrait.enable
	local USE_PORTRAIT_OVERLAY = (db.portrait and db.portrait.overlay) and USE_PORTRAIT

	-- Empty Bar
	do
		local health = frame.Health
		local power = frame.Power
		
		if USE_POWERBAR_OFFSET then
			bar:Point('TOPLEFT', power, 'BOTTOMLEFT', -BORDER, -3)
			bar:Point('BOTTOMRIGHT', power, 'BOTTOMRIGHT', BORDER, -EMPTY_BARS_HEIGHT)
		elseif USE_MINI_POWERBAR or USE_INSET_POWERBAR then
			bar:Point('TOPLEFT', health, 'BOTTOMLEFT', -BORDER, -3)
			bar:Point('BOTTOMRIGHT', health, 'BOTTOMRIGHT', BORDER, -EMPTY_BARS_HEIGHT)
		elseif POWERBAR_DETACHED or not USE_POWERBAR then
			bar:Point('TOPLEFT', health.backdrop, 'BOTTOMLEFT', 0, -1)
			bar:Point('BOTTOMRIGHT', health.backdrop, 'BOTTOMRIGHT', 0, -EMPTY_BARS_HEIGHT)
		else
			bar:Point('TOPLEFT', power, 'BOTTOMLEFT', -BORDER, -3)
			bar:Point('BOTTOMRIGHT', power, 'BOTTOMRIGHT', BORDER, -EMPTY_BARS_HEIGHT)
		end

		if USE_PORTRAIT and not USE_PORTRAIT_OVERLAY then
			bar:Point("TOPRIGHT", frame.Portrait.backdrop, "TOPRIGHT", 0, -4)
		end
	end

	--Threat
	do
		local threat = frame.Threat

		if db.threatStyle ~= 'NONE' and db.threatStyle ~= nil then
			if db.threatStyle == "GLOW" then
				threat:SetFrameStrata('BACKGROUND')
				threat.glow:ClearAllPoints()
				threat.glow:SetBackdropBorderColor(0, 0, 0, 0)
				if E.private.tukui.unitframes.threat then
					threat.glow:Point("TOPLEFT", bar, "TOPLEFT", -4, 4)
					threat.glow:Point("TOPRIGHT", bar, "TOPRIGHT", 4, 4)
				else
					threat.glow:Point("TOPLEFT", frame.Health.backdrop, "TOPLEFT", -4, 4)
					threat.glow:Point("TOPRIGHT", frame.Health.backdrop, "TOPRIGHT", 4, 4)
				end
				threat.glow:Point("BOTTOMLEFT", bar, "BOTTOMLEFT", -4, -4)
				threat.glow:Point("BOTTOMRIGHT", bar, "BOTTOMRIGHT", 4, -4)

				if USE_MINI_POWERBAR or USE_POWERBAR_OFFSET or USE_INSET_POWERBAR or POWERBAR_DETACHED then
					threat.glow:Point("BOTTOMLEFT", bar, "BOTTOMLEFT", -4, -4)
					threat.glow:Point("BOTTOMRIGHT", bar, "BOTTOMRIGHT", 4, -4)
				end

				if USE_PORTRAIT and not USE_PORTRAIT_OVERLAY then
					threat.glow:Point("TOPRIGHT", frame.Portrait.backdrop, "TOPRIGHT", 4, -4)
					threat.glow:Point("BOTTOMRIGHT", frame.Portrait.backdrop, "BOTTOMRIGHT", 4, -4)
				end
			elseif db.threatStyle == "ICONTOPLEFT" or db.threatStyle == "ICONTOPRIGHT" or db.threatStyle == "ICONBOTTOMLEFT" or db.threatStyle == "ICONBOTTOMRIGHT" or db.threatStyle == "ICONTOP" or db.threatStyle == "ICONBOTTOM" or db.threatStyle == "ICONLEFT" or db.threatStyle == "ICONRIGHT" then
				threat:SetFrameStrata('HIGH')
				local point = db.threatStyle
				point = point:gsub("ICON", "")

				threat.texIcon:ClearAllPoints()
				threat.texIcon:SetPoint(point, frame.Health, point)
			end
		end
	end
end
